﻿using Infragistics.Controls.Charts;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int curPointIndex = -1;
        int movPointIndex = -1;

        int currentIndex = -1;

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = ChartData.GenerateData(100);
        }


        //private void Test()
        //{
        //    Ellipse e = new Ellipse();
        //    e.Width = 10;
        //    e.Height = 10;
        //    e.Fill = Brushes.Black;
        //    Canvas c = new Canvas();
        //    c.Children.Add(e);
        //}

        
        //bool isKeyPressed = false;

        //private void ColumnSeries_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        //{
        //    Path curPath = e.OriginalSource as Path;

        //    int totalPoints = ((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children.Count;

        //    Canvas canvas = ((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas);
        //    for (int i = 0; i < totalPoints; i++)
        //    {
        //        Path path = Utilities.GetDescendantFromType((canvas.Children[i] as Marker), typeof(Path), true) as Path;
        //        if (path.Uid == curPath.Uid)
        //        {
        //            curPointIndex = i;
        //            movPointIndex = i;
        //        }
        //        path.Fill = curPath.Fill;
        //    }



            
        //    //if (columnIndex == (this.DataContext as IEnumerable<object>).Count()-1)
        //    //{
        //    //    Path p1 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex ] as Marker), typeof(Path), true) as Path;
        //    //    Path p2 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex - 1] as Marker), typeof(Path), true) as Path;
        //    //    p1.Fill = p2.Fill;
        //    //}
        //    //else
        //    //{
        //    //    Path p1 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex ] as Marker), typeof(Path), true) as Path;
        //    //    Path p2 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex + 1] as Marker), typeof(Path), true) as Path;
        //    //    p1.Fill = p2.Fill;
        //    //}

        //    (e.OriginalSource as Path).Fill = Brushes.Black;
        //    //Point clikedColumn = (e.OriginalSource as Path).TranslatePoint(new Point(0, 0), (e.OriginalSource as Path).Parent as UIElement);

        //    //ScalerParams sp = new ScalerParams((sender as LineSeries).SeriesViewer.WindowRect,
        //    //                                    (sender as LineSeries).SeriesViewer.ViewportRect,
        //    //                                    false);
        //    //columnIndex = (int)(sender as LineSeries).XAxis.GetUnscaledValue(clikedColumn.X, sp);
        //}


        private void Window_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            Canvas canvas = ((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas);
            if (e.Key == Key.Left && movPointIndex > 0)
            {
                Path p1 = Utilities.GetDescendantFromType((canvas.Children[movPointIndex] as Marker), typeof(Path), true) as Path;
                Path p2 = Utilities.GetDescendantFromType((canvas.Children[movPointIndex - 1] as Marker), typeof(Path), true) as Path;

                p1.Fill = p2.Fill;
                p2.Fill = Brushes.Black;

                currentIndex = movPointIndex - 1;

                movPointIndex--;
                
            }
            if (e.Key == Key.Right && movPointIndex >= 0 && movPointIndex < canvas.Children.Count - 1)
            {
                Path p1 = Utilities.GetDescendantFromType((canvas.Children[movPointIndex] as Marker), typeof(Path), true) as Path;
                Path p2 = Utilities.GetDescendantFromType((canvas.Children[movPointIndex + 1] as Marker), typeof(Path), true) as Path;

                p1.Fill = p2.Fill;
                p2.Fill = Brushes.Black;

                currentIndex = movPointIndex - 1;

                movPointIndex++;
            }
            if (e.Key == Key.Enter && movPointIndex >= 0)
            {
                MessageBox.Show((((canvas.Children[currentIndex] as Marker).Content as DataContext).Item as ChartData).Value1.ToString());                
            }
        }

        private void LineSeries_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //初始化
            int pointCnt = ((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children.Count;

            for (int i = 0; i < pointCnt-1; i++)
            {
                Path path = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[i] as Marker), typeof(Path), true) as Path;
                path.Uid = i.ToString();
            }

            Path curPath = e.OriginalSource as Path;

            int totalPoints = ((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children.Count;

            Canvas canvas = ((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas);
            for (int i = 0; i < totalPoints; i++)
            {
                Path path = Utilities.GetDescendantFromType((canvas.Children[i] as Marker), typeof(Path), true) as Path;
                if (path.Uid == curPath.Uid)
                {
                    curPointIndex = i;
                    movPointIndex = i;
                    currentIndex = i;
                }
                path.Fill = curPath.Fill;
            }

            (e.OriginalSource as Path).Fill = Brushes.Black;
        }


      
    }

    public class ChartData
    {
        public DateTime Date { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Date = DateTime.Now,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Date = DateTime.Now.AddDays(i),
                };

                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }
}
